@import "./variables";
@import "./layout";

$themes: (
  original: (
    background: $color-sub-black,
    backgroundSecondary: $color-thick-black,
    backgroundThick: $color-black,
    backgroundLight: $color-light-black,
    backgroundBright: $color-thick-gray,
    backgroundContrast: $color-white,
    backgroundBlur: $color-blur-black,
    transparent: transparent,
    string: $color-white,
    stringSecondary: $color-green-gray,
    stringAccent: $color-emerald,
    stringContrast: $color-sub-black,
    placeholder: $color-sub-gray,
    border: $color-thick-gray,
    borderSecondary: $color-green-gray,
    borderContrast: $color-white,
    mainDark: $color-dark-emerald,
    main: $color-emerald,
    mainThick: $color-thick-emerald,
    mainLight: $color-light-emerald,
    cancel: $color-thick-gray,
    alert: $color-red,
    success: $color-thick-green,
    warning: $color-orenge,
    danger: $color-red,
    link: $color-sky-blue,
    badge: $color-light-red,
    searchBar: $color-gray,
    category: $color-thick-emerald,
    tag: $color-green-gray,
    playerTint: $color-white,
    playerFilter: $color-fiter-black,
    playerCancel: $color-dark-white,
    premium: $color-gold,
  ),
);

/*
 * Implementation of themes
 */
@mixin themify($themes) {
  @each $theme, $map in $themes {
    .theme-#{$theme} & {
      $theme-map: () !global;
      @each $key, $submap in $map {
        $value: map-get(map-get($themes, $theme), '#{$key}');
        $theme-map: map-merge($theme-map, ($key: $value)) !global;
      }
      @content;
      $theme-map: null !global;
    }
    &.theme-#{$theme} {
      $theme-map: () !global;
      @each $key, $submap in $map {
        $value: map-get(map-get($themes, $theme), '#{$key}');
        $theme-map: map-merge($theme-map, ($key: $value)) !global;
      }
      @content;
      $theme-map: null !global;
    }
  }
}

@function themed($key) {
  @return map-get($theme-map, $key);
}


.theme-original {
  background-color: $color-white;
  color: $color-black;
  @include MQ(M) {
    background-color: $color-white;
  }
}
// .theme-light {
//   background-color: $white;
//   color: $color-text-dark;
//   @include MQ(M) {
//     background-color: $color-background-off-white;
//   }
// }
// .theme-dark {
//   background-color: $color-background-dark;
//   color: $color-text-white;
// }
